import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class learnworms extends PApplet {

public void keyPressed(){
  worms = new ArrayList<Worm>();
}
ArrayList<Worm>worms = new ArrayList<Worm>();
Worm worm;

public void setup(){
  smooth();
  strokeWeight(5);
   size(500,500); 
}
public void draw(){
  background(0);
  if(mousePressed){
     if(worm == null){
        worm = new Worm();
     } else {
        worm.addPoint();
     } 
  } else {
     if(worm != null){
        worms.add(worm);
        worm = null;
     } 
  }
  for(Worm w: worms){
       w.draw(); 
    }
  
if(worm != null){  worm.draw();}

}



class Worm{
   ArrayList<Point>points = new ArrayList<Point>(); 
   float startx, starty;
   float lastx, lasty;
   int ptr;
   int c;
   Worm(){
     c = color(random(128,250),random(128,250),random(128,250));
     startx = mouseX;
     starty = mouseY;
     lastx = startx;
     lasty = starty;
     
   }
   
   
   public void addPoint(){
      points.add(new Point(mouseX-lastx,mouseY-lasty)); 
      lastx = mouseX; lasty = mouseY;
   }
   public void draw(){
     stroke(c);
     float oldx = startx;
     float oldy = starty;
    for(Point p : points){
       line(oldx,oldy,oldx + p.x,oldy + p.y);
       oldx += p.x;
       oldy += p.y;
    } 
    
    if(this != worm){
      if(oldx >= 0 && oldx <= 500 && oldy >= 0 && oldy <= 500){
      Point p = points.get(ptr);
      points.add(p);
      ptr++;
    }
    }
    
   }
   
  
}



class Point{
  float x,y;
  Point(float px, float py){
     x = px; y = py; 
  }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "learnworms" });
  }
}
